<?php
class SPEClass{

    private static $instance;
    private function __construct() { } 
    private function __clone(){} 
 
    public static function getInstance ()
    {
        if (self::$instance === null) {
            self::$instance = new SPEClass();
        }
        return self::$instance;
 
        return (self::$instance === null) ? self::$instance = new SPEClass() : self::$instance;
    }
    
    public function editHeader(){
        //hide for modification time
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/edit.css" />
            <script type="text/javascript" src="../plugins/SpecialPagesExtras/js/jquery-ui.sort.min.js"></script>
        <?php
    }
    
    public function editExtras($specialName){
        $settings = $this->loadSpecialPageSettings($specialName);

        if (empty($settings))
            return;
            
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];

        include('editScripts.php'); //include all js 
    }  

    public function langCopy(){
        $settings = $this->loadGlobalSettings();
        
        if (!function_exists('return_i18n_available_languages') || !$settings['lang-copy'])
            return;
        
        global $url, $pagesArray;
        
        $slug = @$_GET['newid'] ? $_GET['newid'] : $url;

        if (empty($slug)){ //new page with empty slug, not by creating language page
            return;
        }
        //remove language from slug
        if (($pos = strrpos($slug,'_')) !== false){
            $currentLanguage = substr($slug,$pos + 1);
            $slug = substr($slug,0,$pos);
        }
        else{
            $currentLanguage = return_i18n_default_language();
        }
        $l = return_i18n_available_languages($slug);   
        
        //sotre available languages, minus currently edited language
        $languages = array();
        for ($i = 0; $i < count($l); $i++){
            if ($l[$i] != $currentLanguage)
                $languages[] = $l[$i];
        }
        
        if (count($languages)){
            $langContents = array();
            
            for ($i = 0; $i < count($languages); $i++){
                $s = $languages[$i] == return_i18n_default_language() ? $slug : $slug.'_'.$languages[$i];
                
                $langContents[$languages[$i]] = $pagesArray[$s];
                //add content, it does not exist in pageArray;
                $langContents[$languages[$i]]['content'] = returnPageContent($s);
            }
        
            include('langCopyScripts.php'); //include all js 
        }
    }  

    //php security check for required fields
    public function editSaveSecurityCheck(){
        $settings = $this->loadSpecialPageSettings($_POST['post-special']);
        
        if (empty($settings))
            return;
            
        $pattern = '/\s|<br\s*?\/>/mi'; //trim pattern
              
        if ( $settings['pageData']['content-required'] ){
            $content =  @$_POST['post-content'];
            $content = preg_replace($pattern, '', $content); //same pattern as in js
            
            if ($content == '')
                die('SpecialPagesExtras "content-required" security!');
        }
        
        for ($i = 0; $i < count($settings['fieldsData']); $i++) {
            $fData = $settings['fieldsData'][$i];
            
            if (!$fData['required']) //not required
                continue;

            $data = @$_POST['post-sp-'.$fData['name']];
            
            $data = preg_replace($pattern, '', $data); //same pattern as in js
            
            if ($fData['new-type'] == 'multitext')
                $data = str_replace('||', '', $data); //remove multitext separator chars 

            if ($data === '')
                die('SpecialPagesExtras "'.$fData['name'].'" field required security!');
        }
    }    


    public function confHeader(){
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/configure.css" />
        <?php
    }
    
    //used when GS deletes file from uploads, delete cached thumb
    public function onFileDelete(){    
        $path = (isset($_GET['path'])) ? $_GET['path'] : '';
        $id = $_GET['file'];            
        $filepath = GSDATAUPLOADPATH . $path;
        $file =  $filepath . $id;

        //check that path is safe, etc.
        if(path_is_safe($filepath,GSDATAUPLOADPATH) && filepath_is_safe($file,$filepath)){
            if ( file_exists(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/uploads/'.$path . $id) ) { //delete thumb
                unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/uploads/'.$path . $id);
            }      
            if ( file_exists(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/thumbs/'.$path . 'thumbnail.'.$id) ) { //delete thumb for thumbnail 
                unlink(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/thumbs/'.$path . 'thumbnail.'.$id);
            }
        }	
    }
    
    //used when GS deletes empty folder from uploads
    public function onFolderDelete(){
        $path = (isset($_GET['path'])) ? $_GET['path'] : '';
        $folder = $_GET['folder'];
        $target = GSDATAUPLOADPATH . $path . $folder;
        
        //check that path is safe for uploads
        if (path_is_safe($target,GSDATAUPLOADPATH)) {
            //removes empty directory, so we believe that all thumbs from that dir was deleted when user deleted files by admin panel
            @rmdir(GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs_cache/uploads/'.$path . $folder);
        }
    }
   
    //work after all scripts
    public function confFooter(){

        if (!isset($_GET['copy'])) //copying old, load copy source settings
            $pageName = @$_GET['edit'] ? @$_GET['edit'] : $_POST['post-name']; //might be new one or eiditng old one
        else
            $pageName = @$_GET['copy'];
            
        $settings = $this->loadSpecialPageSettings($pageName); 
        
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];
        
        include('confScripts.php'); //include all js 
        include('confDialogs.html'); //include dialogs html  
    }
    
    //save settings
    public function confSave(){        
        $fieldsData = array();
    
        for ($i=0; isset($_POST['cf_'.$i.'_name']); $i++) {
            $a = array(
                'name' => $_POST['cf_'.$i.'_name'],
                //supress errors, no javascript set empty vars
                'required' => @$_POST['spe_field-'.$i.'-required'] ? 1 : '',
                'description' => @$_POST['spe_field-'.$i.'-description'],
                'new-type' => @$_POST['spe_field-'.$i.'-new-type']
            );

            //store extra params for special types
            switch ($_POST['cf_'.$i.'_type']) {
                case 'image':{
                    $a['thumbnail'] = @$_POST['spe_field-'.$i.'-thumbnail'] ? 1 : '';
                    break;
                }
            }
            
            $fieldsData[] = $a; //add to array
        }

        array_pop($fieldsData); // remove the last hidden line
        
        $this->_confWrite($fieldsData);
        
    }
    
    public function confUndo(){
        $name = preg_match('/^[A-Za-z0-9-]+$/', @$_GET['edit']) ? $_GET['edit'] : null;
        $newname = @$_GET['new'];
    
        //supress errors, no extra data
        @unlink(GSDATAOTHERPATH.'i18n_special-' . $newname . '-extras.xml'); //delete old
        @copy(GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml', GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml');
    }
    
    
    public function confDelete(){
        $name = $_GET['delete']; 
         //supress errors, no extra data
        @copy(GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml', GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml');
        @unlink(GSDATAOTHERPATH . 'i18n_special-' . $name . '-extras.xml');
    }
    
    public function globalConfHeader(){
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/globalConf.css" />
        <?php
    }    

    public function globalConfFooter(){
        // $settings = $this->settings->getArray();
        echo '<script>';
        require_once('globalConfScripts.php');
        echo '</script>';
    } 
    
    
    //global plugin settings
    public function loadGlobalSettings(){
        $xml = getXML(GSDATAOTHERPATH . 'SpecialPagesExtras/config.xml');  
        
        $data = array();
        $data['lang-copy'] = (string)@$xml->{'lang-copy'};

        return $data;
    }   

    public function saveGlobalSettings(){
        $xml = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><SpecialPagesExtras></SpecialPagesExtras>');
        
        $xml->addChild('lang-copy', (bool)@$_POST['lang-copy']);
   
        return XMLsave($xml, GSDATAOTHERPATH . 'SpecialPagesExtras/config.xml');
    }   
    
    

    public function loadSpecialPageSettings($pageName){
        $ret = array();
    
        $xml = getXML(GSDATAOTHERPATH.'i18n_special-' . $pageName . '-extras.xml');       
     
        //parse data from settings
        if ($xml){
            foreach ($xml->page->children() as $pageSetting)
            {
                $name = $pageSetting->getName();
                $ret['pageData'][$name] = (string)$pageSetting;
            }     

            foreach ($xml->fields->children() as $field)
            {      
                $fieldsData[] = array();
            
                foreach ($field->children() as $fieldSetting)
                {               
                    $name = $fieldSetting->getName();
                    $ret['fieldsData'][ count($fieldsData) - 1 ][$name] = (string)$fieldSetting;
                }
            }
        }
        
        return $ret;
    }

    //writes xml data
    private function _confWrite($fieldsData){    
        $data = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><extras></extras>');
        $page = $data->addChild('page');
        
        $page->addChild('title-label-show', isset($_POST['spe_page-title-label-show']) ? 1 : '');
        $page->addChild('title-label')->addCData($_POST['spe_page-title-label']);
        $page->addChild('content-label-show', isset($_POST['spe_page-content-label-show']) ? 1 : '');
        $page->addChild('content-label')->addCData($_POST['spe_page-content-label']);
        $page->addChild('content-required', isset($_POST['spe_page-content-required']) ? 1 : '');
        $page->addChild('tags-hide', isset($_POST['spe_page-tags-hide']) ? 1 : '');
        $page->addChild('meta-description-hide', isset($_POST['spe_page-meta-description-hide']) ? 1 : '');
        
        $fields = $data->addChild('fields');
        
        for ($i = 0; $i < count($fieldsData); $i++){
            $f = $fields->addChild('field');
            
            //iterate over params and add to xml
            foreach ($fieldsData[$i] as $key => $value){
                $f->addChild($key)->addCData($value);
            }
        }
        
        //store backup
        $oldName = @$_GET['edit'];
        
        if ($oldName && file_exists(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml')) {
            @copy(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml', GSBACKUPSPATH . 'other/i18n_special-' . $oldName . '-extras.xml'); //create copy
            @unlink(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml'); //delete old
        }
        
        //name must be with minus char not underscore to not be identified as special page type file
        XMLsave($data, GSDATAOTHERPATH . 'i18n_special-' . $_POST['post-name'] . '-extras.xml');
         
    }
    
    

}