<?php global $SITEURL; ?>

<script>
    $(document).ready(function() {  

        //generated by php
        var fieldsData = <?php echo json_encode($fieldsData) ?>;
        var pageData = <?php echo json_encode($pageData) ?>;
        
        var $editForm = $('#editform'),
            reqImg = ' <img class="spe_img" src="../plugins/SpecialPagesExtras/img/required.png"  />';
            
        var sortableOpts = {            
            items:'.spe_row',
            helper : function(event, row){ //fixes resizing row issues
                return row.clone();
            },
            placeholder: {
                element: function(currentItem) { //fixes resizing row issues
                    return multiTextRow('', true);
                },
                update: function(container, p) {
                    return;
                }
            }
        }
        
        //page modifications
        if (pageData['title-label-show']){
            $('label[for="post-title"]').show();
        }      
        if (pageData['title-label']){
            $('label[for="post-title"]').html(pageData['title-label'])
            $('#post-title').removeAttr('placeholder');
        }    
        if (pageData['content-label-show']){
            $('label[for="post-content"]').show();
        }      
        if (pageData['content-label']){
            $('label[for="post-content"]').html(pageData['content-label']);
        }   
        if (pageData['content-required']){
            var $cLab = $('label[for="post-content"]');
            $cLab.html($cLab.html() + reqImg);
            $('#post-content').attr('data-required', '');
        }    
        if (pageData['tags-hide']){
            $('#post-metak').closest('p').hide();
        }    
        if (pageData['meta-description-hide']){
            $('#post-metad').closest('p').hide();
        }
        
        //field modifications
        if (fieldsData){
      
            $.each(fieldsData, function(index, value){
                $input = $editForm.find(':input[id="post-sp-'+ value.name +'"]'),
                $td = $input.closest('td');
                 
                if ( value.description ){
                    var $b = $td.find('b');
                        
                    $b.text($b.text().slice(0,-1));
                    $input.before('<div class="spe_description">' + value.description + '</div>');
                }    
                
                if ( value.required ){
                    $input.attr('data-required', ''); 
                    $td.find('b').after(reqImg);
                }
                
                //is image type and thumbnail parameter requested
                if (typeof(value.thumbnail) !== 'undefined' && value.thumbnail){
                    var $img = $('<img src="'+getThumbSrc( $input.val())+'" class="spe_thumbnail" /> ');
                    $input.before($img);
                    
                    //on input change update thumbnail
                    $input.change(function(event){
                        $img.attr('src', getThumbSrc( $(this).val() ) );
                    });
                    
                    //find number of field
                    var iNum = $editForm.find(':input[id^="post-sp-"]').index($input) + 1;
                    //override function used to fill input field after browse action
                    var oldFunc = window['fill_sp_' + iNum];
                    window['fill_sp_' + iNum] = function(url){
                        oldFunc(url);
                        $img.attr('src', getThumbSrc(url) );
                    };
                }
                
                if (value['new-type'] == 'multitext'){
                    $input
                        .hide()
                        .change(function(){ // use change handler to support changing data by language copier
                            var $inp = $(this);
   
                            $inp.next('.spe_multitext').remove(); 
                        
                            var values = $inp.val().split('||'),
                                html = '<div class="spe_multitext">';
                            
                            for (var i=0; i < values.length; i++)
                            { 
                                html += multiTextRow(values[i]);
                            }
                            html += '<button type="button" class="spe"><?php i18n('SpecialPagesExtras/ADD') ?></button>';
                            html += '</div>';
                            
                            var $multiDiv = $(html);
     
                            $inp.closest('td').append($multiDiv);
                            
                            //sortable fields
                            $multiDiv.sortable(sortableOpts);
                            
                        })
                        .trigger('change');
                }
            });
        }
        
        //multitext delete handler
        $editForm.on('click', '.spe_multitext .spe_delete', function(event){
            event.preventDefault();
            
            var $a = $(this);
            $a.closest('.spe_row').remove();
        });  

         //multitext add handler
        $editForm.on('click', '.spe_multitext .spe', function(event){
            event.preventDefault();
            
            var $a = $(this);
            $a.before(multiTextRow(''));
        });
        
        
        $editForm.submit(function(event){
            
            var errors = false,
                openOptions = false;
                
            //fill multitext
            $editForm.find('.spe_multitext').each(function(){
                var $multiText = $(this),
                    $input = $multiText.siblings('input[type="text"]'),
                    vals = [];
                    
                $multiText.find('input').each(function(){
                    var val = $(this).val().trim();
                    
                    if (val)
                        vals.push(val);
                });
                
                $input.val(vals.join('||'));
            });
                
            if (typeof CKEDITOR != 'undefined' && CKEDITOR.instances){
                //update now
                for(var i in CKEDITOR.instances) {
                   /* this updates the value of the textarea from the CK instances.. */
                   CKEDITOR.instances[i].updateElement();
                }
            }
                
            $editForm.find('input[data-required],select[data-required],textarea[data-required]').each(function(){
                var $input = $(this),
                    $td = $input.closest('td');
                
                if ( !$input.val().replace(/\s/gm, '').replace(/<br\s*?\/>/gmi, '') ){ //replace br from empty cke editor
                
                    if ($input.next('span[id^="cke_"]').length){ //is cke editor
                        $input.next('span[id^="cke_"]').addClass('spe_validation-error');
                    }
                    else{
                        $td.addClass('spe_validation-error');
                    }
                    
                    //is part of special fields
                    if ($input.closest('.specialtable').length)
                        openOptions = true;
                        
                    errors = true;
                }
                else{
                   $td.removeClass('spe_validation-error');
                   $input.next('span[id^="cke_"]').removeClass('spe_validation-error');
                }
                
            });
            
            if (openOptions && $('#metadata_window').is(':hidden') ){
                $('#metadata_window').slideToggle('fast');
                $('#metadata_toggle').toggleClass('current');
            }
            
            if (errors){
                $('.error').remove();
                $('div.bodycontent').before('<div class="error" style="display:block;"><?php  i18n('SpecialPagesExtras/VALIDATION_ERROR');?></div>');
                $('.error').fadeOut(500).fadeIn(500);
                
                $('body,html').animate({scrollTop: 0}, 500);
                
                event.preventDefault();
            }   
        });
        
        
        function getThumbSrc(imgUrl){
            return '<?php echo $SITEURL; ?>plugins/SpecialPagesExtras/thumb/?img='+ encodeURIComponent(imgUrl) +'&no=<?php urlencode(i18n('SpecialPagesExtras/IMAGE_NO_IMAGE'));?>&ni=<?php urlencode(i18n('SpecialPagesExtras/IMAGE_NOT_IMAGE'));?>&nf=<?php urlencode(i18n('SpecialPagesExtras/IMAGE_NOT_FOUND'));?>'
        }     

        function multiTextRow(value, empty){
            return '<div class="spe_row"><div class="spe_cell">' + (empty ? '' : '<input type="text" value="'+value+'" />')+'</div><div class="spe_cell spe_delete">'+ (empty ? '' : '<a href="#"  title="<?php i18n('SpecialPagesExtras/DELETE') ?>">X</a>')+ '</div><div class="spe_cell spe_drag"><img class="spe_img" src="../plugins/SpecialPagesExtras/img/drag.png"  /></div></div>'
        }
    });
</script>